function testMFA() 
    close all;
    clear all;
    
    % To demonstrate the software we generate a sample data set
    % from a mixture of two Gaussians
%    X1=randn(300,2);	% zero mean 5 dim Gaussian data 
%    X2=randn(200,2)+2;	% 5 dim Gaussian data with mean [1 1 1 1 1]
%    X=[X1;X2];		% total 500 data points from mixture
    
    file = '../msvc/data_unifang_radialgauss1.data';
    %file = '../msvc/dataset7.data';
    %file = '../msvc/dataset1.data';
    dims_data = 2;
    dims_file = 3;
    D = loadData(file,dims_file);
    cols= size(D,2);
    X = D(:,1:cols-1);
    Y = D(:,cols);

    [Lh,Ph,Mu,Pi,LL]=mfa(X,20,2);
    % Lh, Ph, Mu, and Pi are the factor loadings, observervation
    % variances, observation means for each mixture, and mixing
    % proportions. LL is the vector of log likelihoods (the learning
    % curve). For more information type: help mfa

    Params = clusterData(X, Lh, Ph, Mu, Pi); % returns a cell array. The first element the labels, the second - the cluster means, the third - the covariances
    Lbls = Params{1};
    ClusterMeans = Params{2};
    CovMatrices = Params{3};
    
    lbls_type = unique(Lbls);
    num_lbls = size(lbls_type,1);
    color_map = ['b'; 'r'; 'g'; 'm'; 'y'; 'k'; 'c']; 
    hold on;
    for i = 1:num_lbls
        inds = find(Lbls(:,1) == lbls_type(i));
        col = rem(i-1, size(color_map,1))+1;
        col = color_map(col,1); 
        plot(X(inds,1),X(inds,2), ['.' col], 'LineWidth', 1);
%         meanCluster = ClusterMeans(lbls_type(i),:);
%         %covMatr = CovMatrices{lbls_type(i)};
%         examp = X(inds,:);
%         covMatr = cov(examp);
%         
%         draw_ellipse(meanCluster, covMatr, col, 1);  
%         hold on;
    end;
    axis([-4,4,-4,4]); 
    
    figure;
    hold on;
    for i = 1:num_lbls
        inds = find(Lbls(:,1) == lbls_type(i));
        col = rem(i-1, size(color_map,1))+1;
        col = color_map(col,1); 
        plot(X(inds,1),X(inds,2), ['.' col], 'LineWidth', 1);
        
        meanCluster = ClusterMeans(lbls_type(i),:);
        %covMatr = CovMatrices{lbls_type(i)};
        examp = X(inds,:);
        covMatr = cov(examp);
        
        draw_ellipse(meanCluster, covMatr, col, 1);  
        hold on;
    end;
    axis([-4,4,-4,4]); 